.686p
.model flat,stdcall

INCLUDE nop_macro.inc
INCLUDE pe.inc
INCLUDE prot_macro.inc
include hde32.ash

RvaToOffset PROTO Rva:DWORD, ImageNtHeaders:DWORD
OffsetToRva PROTO Offs:DWORD, ImageNtHeaders:DWORD
IntervalRand PROTO LowValue:DWORD, HighValue:DWORD
ContinueWork PROTO Info:DWORD
Build1Loader PROTO pPEInfo:DWORD, LdrOffset:DWORD, JmpAddress:DWORD
Build15Loader PROTO pPEInfo:DWORD, LdrOffset:DWORD, RealLdrAddress:DWORD, RealLdrSize:DWORD, RealLdrDSize:DWORD
EncryptCode PROTO pPEInfo:DWORD, Key:DWORD
EncryptData PROTO pPEInfo:DWORD, Key:DWORD
EncryptRData PROTO pPEInfo:DWORD, Key:DWORD


PEInfo STRUC
	hPEFile				dd ?
	hMappedFile			dd ?
	FileBase			dd ?
	ImageDosHeader		dd ?
	ImageNtHeaders		dd ?
	ImageFileHeader		dd ?
	ImageOptionalHeader	dd ?
	WorkingSection		dd ?
PEInfo ENDS

LoaderInfo STRUC
	pPEInfo				dd ?
	OriginalRelocRVA	dd ?
	CurrentOffset		dd ?
	OriginalITRVA		dd ?
	OriginalETRVA		dd ?
	TextRVA				dd ?
	TextSize			dd ?
	DataRVA				dd ?
	DataSize			dd ?
	RDataRVA			dd ?
	RDataSize			dd ?
	Imports				dd ?
LoaderInfo ENDS

.data
ITOffset		dd 0
OEPRva			dd 0
NextStageRVA	dd 0
NextStageOff	dd 0
RealLdrRVA		dd 0
OldCodeOffs		dd 0
OldCodeSize		dd 0
TmpStruct		hde32s <>

.code
assume fs:nothing

real_loader_start:
OriginalReloc		dd 0 ; RVA of original (encrypted) relocations [esi+0]
OriginalCode		dd 0 ; RVA of original code (moved by packer) [esi+4]
OriginalCodeSize	dd 0 ; Size of original code [esi+8]
OriginalEP			dd 0 ; RVA of original entry point [esi+0C]
MyImageBase			dd 0 ; current image base [esi+10]
OldImageBase		dd 0 ; preferred image base [esi+14]
Key					dd 4 dup(0) ; key used for decryption [esi+18]
BaseAddress			dd 0 ; used to set up obfuscation [esi+28]
TextRVA				dd 0 ; RVA of .text section [esi+2C]
TextSize			dd 0 ; size of .text section [esi+30]
DataRVA				dd 0 ; RVA of .data section [esi+34]
DataSize			dd 0 ; size of .data section [esi+38]
RDataRVA			dd 0 ; RVA of .rdata section [esi+3C]
RDataSize			dd 0 ; size of .rdata section [esi+40]
OriginalITRVA		dd 0 ; RVA of original import table [esi+44]
OriginalETRVA		dd 0 ; RVA of original export table [esi+48]
apiGetProcAddress	dd 0 ; RVA of GetProcAddress IAT Entry [esi+4C]
apiLoadLibraryA		dd 0 ; RVA of LoadLibraryA IAT Entry [esi+50]
GPBuffer			db 32h dup(0) ; general purpose buffer [esi+54]
m_traceflag			db 0	; Debugger Condition [esi+86h]

size_ldr_data		EQU $ - real_loader_start

real_loader_start_first:
	m_pop esi ;esi = real_loader_start VA, stack - 4
	
	m_push	eax
	
	push	ss
	xor		ax, ax
	pop		ss
	pushfd
	push	ss
	pop		ss
	popfd
	m_and	ax, 100h
	m_shr	ax, 8
	m_mov	byte ptr [esi+86h], al
	m_pop	eax
	
	m_mov [esi+10h], eax ; store current image base
	
	gen_instr2 mov, eax, [esi+04h]
	gen_instr2 add, eax, [esi+10h] ; eax = OriginalCode VA
	gen_instr2 mov, ebx, [esi+0Ch]
	gen_instr2 add, ebx, [esi+10h] ; ebx = OriginalEP VA
	gen_instr2 mov, [esi+0Ch], ebx ; save OEP V
	
	gen_instr2 push, ebx
	gen_instr2 mov, ebx, esi
	gen_instr2 add, ebx, nextRet - real_loader_start
	seh_call call_handler, build_code_key, esi, ebx
	
nextRet:
; restore original code
	m_pop ebx
	gen_instr2 mov, ecx, [esi+08h]
	gen_instr2 push, esi
	gen_instr2 mov, esi, eax
	gen_instr2 mov, edi, ebx
	gen_instr2 rep, movsb
	gen_instr2 pop, esi
	
	gen_instr2 push, esi
	gen_instr2 mov, ebp, esi
	gen_instr2 mov, esi, [ebp+2Ch]
	gen_instr2 add, esi, [ebp+10h]
	gen_instr2 mov, ecx, [ebp+30h]
	gen_instr2 call, seh_decrypt ; decrypt .text section
	gen_instr2 pop, esi
	
	gen_instr2 push, ebx
	gen_instr2 mov, ebx, esi
	gen_instr2 add, ebx, nextRet2 - real_loader_start
	seh_call call_handler, build_data_key, esi, ebx
	
nextRet2:
	m_pop ebx
	gen_instr2 push, esi
	gen_instr2 mov, ebp, esi
	gen_instr2 mov, esi, [ebp+34h]
	gen_instr2 add, esi, [ebp+10h]
	gen_instr2 mov, ecx, [ebp+38h]
	gen_instr2 call, seh_decrypt ; decrypt .data section
	gen_instr2 pop, esi
	
	gen_instr2 push, ebx
	gen_instr2 mov, ebx, esi
	gen_instr2 add, ebx, nextRet3 - real_loader_start
	seh_call call_handler, build_rdata_key, esi, ebx
	
nextRet3:
	m_pop ebx
	gen_instr2 push, esi
	gen_instr2 mov, ebp, esi
	gen_instr2 mov, esi, [ebp+3Ch]
	gen_instr2 add, esi, [ebp+10h]
	gen_instr2 mov, ecx, [ebp+40h]
	gen_instr2 call, seh_decrypt ; decrypt .rdata section
	gen_instr2 pop, esi
	
	gen_instr2 push, ebx
	gen_instr2 mov, ebx, esi
	gen_instr2 add, ebx, nextRet5 - real_loader_start
	seh_call call_handler, build_rdata_key2, esi, ebx
	
nextRet5:
	m_pop ebx
	gen_instr2 push, esi
	gen_instr2 mov, ebp, esi
	gen_instr2 mov, esi, [ebp+3Ch]
	gen_instr2 add, esi, [ebp+10h]
	gen_instr2 mov, ecx, [ebp+40h]
	gen_instr2 call, seh_decrypt ; decrypt .rdata section
	gen_instr2 pop, esi
	
	gen_instr2 call, handle_reloc ; handle relocations
	
	gen_instr2 push, ebx
	gen_instr2 mov, ebx, esi
	gen_instr2 add, ebx, nextRet4 - real_loader_start
	seh_call call_handler, handle_it, esi, ebx
	
nextRet4:
	gen_instr2 pop ebx
	gen_instr2 mov, eax, [esi+0Ch]
	gen_instr2 mov, [esp+24h], eax ; eax = OEP
	m_instr popad
	m_instr popfd ; return address now on top of the stack
	m_instr ret ; jmp to OEP
	
handler:
	m_mov ecx, [esp+0Ch]
	gen_instr2 mov, dword ptr [ecx+04h], 0
	gen_instr2 mov, dword ptr [ecx+08h], 0
	gen_instr2 mov, dword ptr [ecx+0Ch], 0
	gen_instr2 mov, dword ptr [ecx+10h], 0
	gen_instr2 mov, dword ptr [ecx+14h], 0
	gen_instr2 mov, dword ptr [ecx+18h], 155h
	gen_instr2 mov, ebx, [ecx+0A4h]
	gen_instr2 push, ecx
	gen_instr2 push, ebx
	gen_instr2 cpuid
	gen_instr2 rdtsc
	gen_instr2 pop, ebx
	gen_instr2 pop, ecx
	gen_instr2 sub, eax, ebx
	gen_instr2 cmp, eax, 10000000h
	IFNDEF _DEBUG
		gen_instr2 ja, crash_it
	ENDIF
	gen_instr2 mov, eax, dword ptr [ecx+0B4h]
	gen_instr2 add, eax, do_decrypt - real_loader_start
	gen_instr2 mov, dword ptr [ecx+0B8h], eax
	m_xor eax, eax
	m_instr ret
	
call_handler:
	gen_instr2 mov, ecx, [esp+0Ch]
	gen_instr2 mov, dword ptr [ecx+04h], 0
	gen_instr2 mov, dword ptr [ecx+08h], 0
	gen_instr2 mov, dword ptr [ecx+0Ch], 0
	gen_instr2 mov, dword ptr [ecx+10h], 0
	gen_instr2 mov, dword ptr [ecx+14h], 0
	gen_instr2 mov, dword ptr [ecx+18h], 155h
	gen_instr2 mov, ebx, [ecx+0A4h]
	gen_instr2 push, ecx
	gen_instr2 push, ebx
	gen_instr2 cpuid
	gen_instr2 rdtsc
	gen_instr2 pop, ebx
	gen_instr2 pop, ecx
	gen_instr2 sub, eax, ebx
	gen_instr2 cmp, eax, 10000000h
	IFNDEF _DEBUG
		;gen_instr2 ja, crash_it
	ENDIF
	gen_instr2 mov, eax, dword ptr [ecx+09Ch]
	gen_instr2 mov, dword ptr [ecx+0B8h], eax
	m_xor eax, eax
	;IFNDEF _DEBUG
	;	gen_instr2	test, byte ptr [esi+86h], 1
	;	gen_instr2	jz, crash_it
	;ENDIF
	m_instr ret

crash_it:
	m_push ecx
	m_push eax
	m_instr cpuid
	m_instr rdtsc
	m_pop eax
	m_pop ecx
	
	m_mov dword ptr [ecx+0B8h], eax
	m_xor eax, eax
	m_instr ret
	
seh_decrypt:
	gen_instr2 pushad
	gen_instr2 mov, eax, ebp
	gen_instr2 add, eax, handler - real_loader_start
	gen_instr2 push, eax
	gen_instr2 push, fs:[0]
	gen_instr2 mov, fs:[0], esp
	gen_instr2 cpuid
	gen_instr2 rdtsc
	gen_instr2 mov, ebx,eax
	gen_instr2 xor, eax,eax
	gen_instr2 idiv, eax
	m_instr ret
	
build_code_key:
	seh_called
	
	setup_obfuscation build_code_key
	
	gen_instr push, esi, , build_code_key
	gen_instr push, edi, , build_code_key
	gen_instr push, ebx, , build_code_key
	gen_instr push, eax, , build_code_key
	
	gen_instr mov, edi, [esi+10h], build_code_key ; edi = image base
	gen_instr mov, eax, edi, build_code_key
	gen_instr add, eax, [edi.IMAGE_DOS_HEADER.e_lfanew], build_code_key ; eax = PE Header
	gen_instr push, eax, , build_code_key
	gen_instr mov, edi, eax, build_code_key
	gen_instr mov, ebx, [edi.IMAGE_NT_HEADERS.OptionalHeader.IMAGE_OPTIONAL_HEADER.NumberOfRvaAndSizes], build_code_key
	gen_instr mov, [esi+1Ch], ebx, build_code_key
	gen_instr movzx, ebx, [eax.IMAGE_NT_HEADERS.FileHeader.IMAGE_FILE_HEADER.SizeOfOptionalHeader], build_code_key
	gen_instr add, edi, ebx, build_code_key
	gen_instr mov, eax, edi, build_code_key
	gen_instr add, eax, 18h, build_code_key
	gen_instr mov, edi, eax, build_code_key
	gen_instr mov, eax, [edi.IMAGE_SECTION_HEADER.SizeOfRawData], build_code_key
	gen_instr mov, [esi+18h], eax, build_code_key
	gen_instr pop, edi, , build_code_key
	gen_instr mov, ebx, [esi+0Ch], build_code_key
	gen_instr mov, eax, [ebx], build_code_key
	gen_instr mov, [esi+20h], eax, build_code_key
	gen_instr mov, eax, [ebx+4], build_code_key
	gen_instr mov, [esi+24h], eax, build_code_key
	
	gen_instr pop, eax, , build_code_key
	gen_instr pop, ebx, , build_code_key
	gen_instr pop, edi, , build_code_key
	gen_instr pop, esi, , build_code_key
	m_instr ret
	
do_decrypt:
	m_pop fs:[0]
	m_add esp, 4
	m_instr popad
	m_jmp decrypt_section
	
build_data_key:
	seh_called
	
	setup_obfuscation build_data_key
	
	gen_instr push, esi, , build_data_key
	gen_instr push, edi, , build_data_key
	
	gen_instr mov, edi, [esi+10h], build_data_key
	gen_instr mov, eax, edi, build_data_key
	gen_instr add, eax, [edi.IMAGE_DOS_HEADER.e_lfanew], build_data_key
	gen_instr mov, edi, eax, build_data_key
	gen_instr movzx, ebx, [edi.IMAGE_NT_HEADERS.FileHeader.IMAGE_FILE_HEADER.SizeOfOptionalHeader], build_data_key
	gen_instr add, edi, ebx, build_data_key
	gen_instr mov, eax, edi, build_data_key
	gen_instr add, eax, 18h, build_data_key
	gen_instr mov, edi, eax, build_data_key
	gen_instr mov, eax, [edi.IMAGE_SECTION_HEADER.SizeOfRawData], build_data_key
	gen_instr mov, [esi+18h], eax, build_data_key ; key[0] = g_dwNewRawSize
	
	gen_instr mov, eax, esi, build_data_key
	gen_instr add, eax, size_ldr_data, build_data_key
	gen_instr push, [eax], , build_data_key
	gen_instr pop, [esi+1Ch], , build_data_key
	gen_instr add, eax, 4, build_data_key
	gen_instr push, [eax], , build_data_key
	gen_instr pop, [esi+20h], , build_data_key
	gen_instr add, eax, 4, build_data_key
	gen_instr mov, ebx, [eax], build_data_key
	gen_instr push, ebx, , build_data_key
	gen_instr pop, [esi+24h], , build_data_key
	
	gen_instr pop,edi, , build_data_key
	gen_instr pop,esi, , build_data_key
	m_instr ret
	
build_rdata_key:
	seh_called
	setup_obfuscation build_rdata_key
	
	gen_instr push, esi, , build_rdata_key
	gen_instr push, edi, , build_rdata_key
	
	gen_instr mov, edi, [esi+10h], build_rdata_key
	gen_instr mov, eax, edi, build_rdata_key
	gen_instr add, eax, [edi.IMAGE_DOS_HEADER.e_lfanew], build_rdata_key
	gen_instr mov, edi, eax, build_rdata_key
	gen_instr movzx, ebx, [edi.IMAGE_NT_HEADERS.FileHeader.IMAGE_FILE_HEADER.SizeOfOptionalHeader], build_rdata_key
	gen_instr add, edi, ebx, build_rdata_key
	gen_instr mov, eax, edi, build_rdata_key
	gen_instr add, eax, 18h, build_rdata_key
	gen_instr mov, edi, eax, build_rdata_key
	gen_instr mov, eax, [edi.IMAGE_SECTION_HEADER.SizeOfRawData], build_rdata_key
	gen_instr mov, [esi+18h], eax, build_rdata_key
	
	gen_instr mov, eax, esi, build_rdata_key
	gen_instr add, eax, build_code_key - real_loader_start, build_rdata_key
	gen_instr sub, eax, 12, build_rdata_key
	gen_instr push, [eax], , build_rdata_key
	gen_instr pop, [esi+1Ch], , build_rdata_key
	gen_instr add, eax, 4, build_rdata_key
	gen_instr push, [eax], , build_rdata_key
	gen_instr pop, [esi+20h], , build_rdata_key
	gen_instr add, eax, 4, build_rdata_key
	gen_instr mov, ebx, [eax], build_rdata_key
	gen_instr push, ebx, , build_rdata_key
	gen_instr pop, [esi+24h], , build_rdata_key
	
	gen_instr pop, edi, , build_rdata_key
	gen_instr pop, esi, , build_rdata_key
	m_instr ret

build_rdata_key2:
	seh_called
	
	setup_obfuscation build_rdata_key2
	
	gen_instr push, esi, , build_rdata_key2
	gen_instr push, edi, , build_rdata_key2
	
	gen_instr mov, edi, [esi+10h], build_rdata_key2
	gen_instr mov, eax, edi, build_rdata_key2
	gen_instr add, eax, [edi.IMAGE_DOS_HEADER.e_lfanew], build_rdata_key2
	gen_instr mov, edi, eax, build_rdata_key2
	gen_instr movzx, ebx, [edi.IMAGE_NT_HEADERS.FileHeader.IMAGE_FILE_HEADER.SizeOfOptionalHeader], build_rdata_key2
	gen_instr add, edi, ebx, build_rdata_key2
	gen_instr mov, eax, edi, build_rdata_key2
	gen_instr add, eax, 18h, build_rdata_key2
	gen_instr mov, edi, eax, build_rdata_key2
	gen_instr mov, eax, [edi.IMAGE_SECTION_HEADER.SizeOfRawData], build_rdata_key2
	gen_instr mov, [esi+18h], eax, build_rdata_key2
	
	gen_instr mov, eax, esi, build_rdata_key2
	gen_instr add, eax, seh_decrypt - real_loader_start, build_rdata_key2
	gen_instr add, eax, build_code_key - seh_decrypt, build_rdata_key2
	gen_instr sub, eax, 12, build_rdata_key2
	gen_instr push, [eax], , build_rdata_key2
	gen_instr pop, [esi+1Ch], , build_rdata_key2
	gen_instr add, eax, 4, build_rdata_key2
	gen_instr push, [eax], , build_rdata_key2
	gen_instr pop, [esi+20h], , build_rdata_key2
	gen_instr add, eax, 4, build_rdata_key2
	gen_instr mov, ebx, [eax], build_rdata_key2
	gen_instr push, ebx, , build_rdata_key2
	gen_instr pop, [esi+24h], , build_rdata_key2
	
	gen_instr pop, edi, , build_rdata_key2
	gen_instr pop, esi, , build_rdata_key2
	m_instr ret
	
; decrypt_section
; decrypts a section of the PE Header
; Params:
; esi = section to decrypt
; ecx = length of section
; ebp = pointer to loader data
decrypt_section:

loop1:
	m_mov eax, [esi]			; eax -> y
	m_mov ebx, [esi+4]		; ebx -> z
	
	m_push esi
	m_push ecx
	
	m_test eax, eax
	m_jnz continue
	m_test ebx, ebx
	m_jnz continue
	m_jmp next1
	
continue:
	m_mov	ecx, 20h			; ecx -> n
	m_mov	edx, 0C6EF3720h		; edx -> sum
	
destart:
	m_mov	esi, eax
	m_mov	edi, esi

	m_shl	esi, 4				; y << 4
	m_shr	edi, 5				; y >> 5
	m_xor	edi, esi			; y << 4 ^ y >> 5
	m_add	edi, eax			; (y << 4 ^ y >> 5) + y

	m_mov	esi, edx
	m_shr	esi, 11				; sum >> 11
	m_and	esi, 3				; sum >> 11 & 3
	m_add ebp, 18h
	m_mov	esi, [ebp+esi*4]	; k[sum >> 11 & 3]
	m_sub ebp, 18h
	m_add	esi, edx			; sum + k[sum >> 11 & 3]
	m_xor	esi, edi			; (y << 4 ^ y >> 5) + y ^ sum + k[sum >> 11 & 3]
	m_sub	ebx, esi			; z -= (y << 4 ^ y >> 5) + y ^ sum + k[sum >> 11 & 3]

	m_sub	edx, 09E3779B9h		; sum -= delta

	m_mov	esi, ebx
	m_mov	edi, esi

	m_shl	esi, 4				; z << 4
	m_shr	edi, 5				; z >> 5
	m_xor	edi, esi			; z << 4 ^ z >> 5
	m_add	edi, ebx			; (z << 4 ^ z >> 5) + z

	m_mov	esi, edx
	m_and	esi, 3				; sum & 3
	m_add ebp, 18h
	m_mov	esi, [ebp+esi*4]		; k[sum & 3]
	m_sub ebp, 18h
	m_add	esi, edx			; sum + k[sum & 3]
	m_xor	esi, edi			; (z << 4 ^ z >> 5) + z ^ sum + k[sum & 3]
	m_sub	eax, esi			; y -= (z << 4 ^ z >> 5) + z ^ sum + k[sum & 3]
	
	m_dec ecx
	m_test ecx, ecx
	m_jnz destart
	
	m_pop ecx
	m_pop esi
	m_mov	[esi], eax
	m_mov	[esi+4], ebx
	m_jmp skip_pop
	
next1:
	m_pop ecx
	m_pop esi
	
skip_pop:
	m_add esi, 8
	m_sub ecx,8
	m_test ecx, ecx
	m_jnz loop1
	
	m_instr ret
	
; handle_reloc
; Params:
; esi: address of parameters
handle_reloc:
	m_push esi
	m_push ebp
	
	m_mov ebp, esi
	
	m_mov eax, [esi+10h] ; current image base
	m_mov ebx, [esi+14h] ; preferred image base
	m_cmp eax, ebx ; do we need to relocate?
	m_jz no_reloc
	
	m_sub eax, ebx
	m_mov edx, eax ; edx = delta
	m_push edx
	
	m_mov edi, [esi+10h] ; edi = IMAGE_DOS_HEADER = FileBase
	
	m_push esi
	m_mov esi, edi
	m_add esi, [edi.IMAGE_DOS_HEADER.e_lfanew] ; esi = IMAGE_NT_HEADERS = PE Header
	m_mov eax, [esi.IMAGE_NT_HEADERS.OptionalHeader.IMAGE_OPTIONAL_HEADER.LoaderFlags]
	m_mov edx, [esi.IMAGE_NT_HEADERS.OptionalHeader.IMAGE_OPTIONAL_HEADER.NumberOfRvaAndSizes]
	m_pop esi
	
	m_mov edi, [esi]
	m_add edi, [esi+10h]
	m_push edi
@@:
	m_mov ebx, [edi]
	m_test ebx, ebx
	m_jz @f
	m_xor ebx, edx
	m_xor ebx, eax
	m_mov [edi], ebx
	m_add edi, 4
	m_jmp @b
@@: ; relocs decrypted, apply them
	m_pop edi
	m_pop edx ; edx = delta
	
	m_push esi
loop2:
	m_mov esi, [edi.IMAGE_BASE_RELOCATION.VirtualAddress]
	m_mov eax, [edi.IMAGE_BASE_RELOCATION.SizeOfBlock]
	m_sub eax, 8
	m_shr eax, 1
	m_mov ecx, eax ; ecx = number of relocs
	m_add edi, 8
	
loop3:
	m_movzx eax, word ptr [edi]
	m_mov ebx, eax
	m_shr eax, 12
	m_test eax, eax
	m_jz next
	m_and ebx, 0FFFh
	m_push esi
	m_add esi, ebx
	m_add esi, [ebp+10h] ; esi = reloc VA
	m_add [esi], edx
	m_pop esi
	m_add edi, 2
	m_dec ecx
	m_test ecx, ecx
	m_jnz loop3
	m_jmp skip_add
	
next:
	m_add edi, 2
	
skip_add:
	m_cmp dword ptr [edi], 0
	m_jnz loop2
	
	m_pop esi
	
no_reloc:
	m_pop ebp
	m_pop esi
	m_instr ret
	
handle_it:
	seh_called
	
	m_push esi
	
	m_mov edi, [esi+44h]
	m_add edi, [esi+10h]
	
do_import:
	m_mov eax, [edi.IMAGE_IMPORT_DESCRIPTOR.Name1]
	m_test eax, eax
	m_jz done_it
	m_add eax, [esi+10h]
	m_push edi
	m_mov edi, [esi+50h]
	m_add edi, [esi+10h]
	m_push eax
	m_call dword ptr [edi]
	m_mov ebp, eax ; ebp = HANDLE to dll
	m_pop edi
	m_mov eax, [edi.IMAGE_IMPORT_DESCRIPTOR.OriginalFirstThunk]
	m_add eax, [esi+10h]
	m_mov edx, [edi.IMAGE_IMPORT_DESCRIPTOR.FirstThunk]
	m_add edx, [esi+10h]
do_function:
	m_mov ebx, [eax]
	m_test ebx, ebx
	m_jz next_import
	m_push ebx
	m_and ebx, 80000000h
	m_test ebx, ebx
	m_jnz ordinal_import
	m_pop ebx
	m_add ebx, [esi+10h]
	m_add ebx, 2
	m_push edi
	m_push eax
	m_push edx
	m_mov edi, [esi+4Ch]
	m_add edi, [esi+10h]
	m_push ebx
	m_push ebp
	m_call dword ptr [edi]
	m_pop edx
	m_mov [edx], eax
	m_pop eax
	m_pop edi
	m_jmp next_thunk
ordinal_import:
	m_pop ebx
	m_sub ebx, 80000000h
	m_and ebx, 0FFFFh
	m_push edi
	m_push eax
	m_push edx
	m_mov edi, [esi+4Ch]
	m_add edi, [esi+10h]
	m_push ebx
	m_push ebp
	m_call dword ptr [edi]
	m_pop edx
	m_mov [edx], eax
	m_pop eax
	m_pop edi
next_thunk:
	m_add eax, 4
	m_add edx, 4
	m_jmp do_function
next_import:
	m_add edi, 14h
	m_jmp do_import
done_it:
	IFNDEF _DEBUG
		;gen_instr2	test, byte ptr [esi+86h], 1
		;gen_instr2	jz, crash_it
	ENDIF
	m_pop esi
	m_instr ret
	
real_loader_end:
real_loader_size EQU $ - real_loader_start
real_loader_enc  EQU $ - real_loader_start_first

; fake import table, only GetProcAddress and LoadLibraryA will be used by loader
it_start:
k32_original	dd k32_imports - k32_original
				dd 0
				dd 0
k32_dll			dd k32_name - k32_original
k32_first		dd k32_iat_start - k32_original

u32_original	dd u32_imports - k32_original
				dd 0
				dd 0
u32_dll			dd u32_name - k32_original
u32_first		dd u32_iat_start - k32_original

gdi32_original	dd gdi32_imports - k32_original
				dd 0
				dd 0
gdi32_dll		dd gdi32_name - k32_original
gdi32_first		dd gdi32_iat_start - k32_original

aapi32_original	dd aapi32_imports - k32_original
				dd 0
				dd 0
aapi32_dll		dd aapi32_name - k32_original
aapi32_first	dd aapi32_iat_start - k32_original

null_descr   dd 0
			 dd 0
			 dd 0
			 dd 0
			 dd 0
			 
k32_name	 db 'KERNEL32.dll',0
k32_imports  dd import1 - k32_original
			 dd import2 - k32_original
			 dd import3 - k32_original
			 dd import4 - k32_original
			 dd import5 - k32_original
			 dd import6 - k32_original
			 dd import7 - k32_original
			 dd import8 - k32_original
			 dd import9 - k32_original
			 dd import10 - k32_original
			 dd import11 - k32_original
			 dd import12 - k32_original
			 dd import13 - k32_original
			 dd import14 - k32_original
			 dd import15 - k32_original
			 dd import16 - k32_original
			 dd import17 - k32_original
			 dd 0

u32_name	 db 'USER32.dll',0
u32_imports  dd import18 - k32_original
			 dd import19 - k32_original
			 dd import20 - k32_original
			 dd import21 - k32_original
			 dd import22 - k32_original
			 dd import23 - k32_original
			 dd 0
			 
gdi32_name	db 'GDI32.dll',0
gdi32_imports	dd import24 - k32_original
				dd import25 - k32_original
				dd import26 - k32_original
				dd import27 - k32_original
				dd 0
				
aapi32_name db 'ADVAPI32.dll',0
aapi32_imports	dd import28 - k32_original
				dd import29 - k32_original
				dd import30 - k32_original
				dd 0
								
k32_iat_start:
impGetProcAddress	dd import1 - k32_original
impLoadLibraryA		dd import2 - k32_original
impk32_3			dd import3 - k32_original
impk32_4			dd import4 - k32_original
impk32_5			dd import5 - k32_original
impk32_6			dd import6 - k32_original
impk32_7			dd import7 - k32_original
impk32_8			dd import8 - k32_original
impk32_9			dd import9 - k32_original
impk32_10			dd import10 - k32_original
impk32_11			dd import11 - k32_original
impk32_12			dd import12 - k32_original
impk32_13			dd import13 - k32_original
impk32_14			dd import14 - k32_original
impk32_15			dd import15 - k32_original
impk32_16			dd import16 - k32_original
impk32_17			dd import17 - k32_original
k32_iat_end:

u32_iat_start:
impu32_1			dd import18 - k32_original
impu32_2			dd import19 - k32_original
impu32_3			dd import20 - k32_original
impu32_4			dd import21 - k32_original
impu32_5			dd import22 - k32_original
impu32_6			dd import23 - k32_original
u32_iat_end:

gdi32_iat_start:
impgdi32_1			dd import24 - k32_original
impgdi32_2			dd import25 - k32_original
impgdi32_3			dd import26 - k32_original
impgdi32_4			dd import27 - k32_original
gdi32_iat_end:

aapi32_iat_start:
impaapi32_1			dd import28 - k32_original
impaapi32_2			dd import29 - k32_original
impaapi32_3			dd import30 - k32_original
aapi32_iat_end:

import1	db 0A0h,01h,'GetProcAddress',0
import2	db 52h, 02, 'LoadLibraryA', 0
import3	db 81h,03h,'VirtualAlloc',0
import4 db 83h,03h,'VirtualFree',0
import5 db 1Ch,02h,'HeapSize',0
import6 db 24h,03h,'SetHandleCount',0
import7 db 0B9h,01h,'GetStdHandle',0
import8 db 10h,01h,'GetCommandLineA',0
import9 db 1Ah,02h,'HeapReAlloc',0
import10 db 16h,02h,'HeapFree',0
import11 db 10h,02h,'HeapAlloc',0
import12 db 37h,03h,'SetStdHandle',0
import13 db 33h,01h,'GetConsoleMode',0
import14 db 22h,01h,'GetConsoleCP',0
import15 db 99h,03h,'WriteConsoleA',0
import16 db 0A3h,03h,'WriteConsoleW',0
import17 db 0D7h,02h,'RtlUnwind',0
import18 db 3Ah,01h,'GetMessageA',0
import19 db 00h,02h,'PeekMessageA',0
import20 db 6Dh,01h,'GetWindowInfo',0
import21 db 0Ch,01h,'GetDC',0
import22 db 7Ah,01h,'GetWindowTextW',0
import23 db 0A1h,02h,'ToUnicode',0
import24 db 0Eh,02h,'SelectObject',0
import25 db 08Fh,00h,'DeleteObject',0
import26 db 12h,00h,'BitBlt',0
import27 db 6Ah,01h,'GetDIBits',0
import28 db 0D0h,01h,'RegCreateKeyA',0
import29 db 0F7h,01h,'RegQueryValueExA',0
import30 db 0CBh,01h,'RegCloseKey',0

	align 4
it_end:
			
ContinueWork PROC uses esi edi Info:DWORD
	mov esi, Info
	test esi, esi
	jz @invalid_info
	
	mov edi, [esi.LoaderInfo.pPEInfo]
	mov esi, [edi.PEInfo.ImageNtHeaders]
	mov eax, [esi.IMAGE_NT_HEADERS.OptionalHeader.IMAGE_OPTIONAL_HEADER.AddressOfEntryPoint]
	mov [OEPRva], eax
	mov esi, Info
	
	call BeginRandomGenerator
	call BuildNewIT
	call PrepareAndCopyLdrs
	
	mov eax, 1
	jmp @end1
@invalid_info:
	xor eax, eax
@end1:
	ret
ContinueWork ENDP

; BuildNewIT
; Builds the new import table
; Params:
; esi: Pointer to LoaderInfo structure
BuildNewIT:
	mov edi, [esi.LoaderInfo.pPEInfo]
	mov eax, [esi.LoaderInfo.CurrentOffset]
	mov [ITOffset], eax
	invoke OffsetToRva, eax, [edi.PEInfo.ImageNtHeaders]
	
	;fixup kernel32 imports
	add [k32_original], eax
	add [k32_dll], eax
	add [k32_first], eax
	add [k32_imports], eax
	add [k32_imports+04h], eax
	add [k32_imports+08h], eax
	add [k32_imports+0Ch], eax
	add [k32_imports+10h], eax
	add [k32_imports+14h], eax
	add [k32_imports+18h], eax
	add [k32_imports+1Ch], eax
	add [k32_imports+20h], eax
	add [k32_imports+24h], eax
	add [k32_imports+28h], eax
	add [k32_imports+2Ch], eax
	add [k32_imports+30h], eax
	add [k32_imports+34h], eax
	add [k32_imports+38h], eax
	add [k32_imports+3Ch], eax
	add [k32_imports+40h], eax	
	add [impGetProcAddress], eax
	add [impLoadLibraryA], eax
	add [impk32_3], eax
	add [impk32_4], eax
	add [impk32_5], eax
	add [impk32_6], eax
	add [impk32_7], eax
	add [impk32_8], eax
	add [impk32_9], eax
	add [impk32_10], eax
	add [impk32_11], eax
	add [impk32_12], eax
	add [impk32_13], eax
	add [impk32_14], eax
	add [impk32_15], eax
	add [impk32_16], eax
	add [impk32_17], eax
	
	;fixup user32 import
	add [u32_original], eax
	add [u32_dll], eax
	add [u32_first], eax
	add [u32_imports], eax
	add [u32_imports+4], eax
	add [u32_imports+8], eax
	add [u32_imports+0Ch], eax
	add [u32_imports+10h], eax
	add [u32_imports+14h], eax
	add [impu32_1], eax
	add [impu32_2], eax
	add [impu32_3], eax
	add [impu32_4], eax
	add [impu32_5], eax
	add [impu32_6], eax
	
	;fixup gdi32 import
	add [gdi32_original], eax
	add [gdi32_dll], eax
	add [gdi32_first], eax
	add [gdi32_imports], eax
	add [gdi32_imports+04h], eax
	add [gdi32_imports+08h], eax
	add [gdi32_imports+0Ch], eax
	add [impgdi32_1], eax
	add [impgdi32_2], eax
	add [impgdi32_3], eax
	add [impgdi32_4], eax
	
	;fixup advapi32 import
	add [aapi32_original], eax
	add [aapi32_dll], eax
	add [aapi32_first], eax
	add [aapi32_imports], eax
	add [aapi32_imports+04h], eax
	add [aapi32_imports+08h], eax
	add [impaapi32_1], eax
	add [impaapi32_2], eax
	add [impaapi32_3], eax
	
	mov eax, [ITOffset]
	add eax, [edi.PEInfo.FileBase]
	push edi
	push esi
	xor ecx, ecx
	lea esi, it_start
	mov edi, eax
	mov ecx, it_end - it_start
	rep movsb
	pop esi
	pop edi
	mov eax, [ITOffset]
	invoke OffsetToRva, eax, [edi.PEInfo.ImageNtHeaders]
	push esi
	mov esi, [edi.PEInfo.ImageNtHeaders]
	mov [esi.IMAGE_NT_HEADERS.OptionalHeader.DataDirectory(IMAGE_DIRECTORY_ENTRY_IMPORT*8).VirtualAddress], eax
	mov [esi.IMAGE_NT_HEADERS.OptionalHeader.DataDirectory(IMAGE_DIRECTORY_ENTRY_IMPORT*8).iSize], 64h
	pop esi
	add [esi.LoaderInfo.CurrentOffset], it_end - it_start
	ret
	
PrepareRealLoader:
	push esi
	push edi
	push ebx
	
	mov eax, [esi.LoaderInfo.OriginalRelocRVA]
	mov [OriginalReloc], eax
	
	mov edi, [esi.LoaderInfo.pPEInfo]
	invoke OffsetToRva, [OldCodeOffs], [edi.PEInfo.ImageNtHeaders]
	mov [OriginalCode], eax
	
	mov eax, [OldCodeSize]
	mov [OriginalCodeSize], eax
		
	mov eax, [OEPRva]
	mov [OriginalEP], eax
	
	mov eax, [edi.PEInfo.ImageNtHeaders]
	mov ebx, [eax.IMAGE_NT_HEADERS.OptionalHeader.IMAGE_OPTIONAL_HEADER.ImageBase]
	mov [OldImageBase], ebx
	
	mov eax, [esi.LoaderInfo.TextRVA]
	mov [TextRVA], eax
	
	mov eax, [esi.LoaderInfo.TextSize]
	mov [TextSize], eax
	
	mov eax, [esi.LoaderInfo.DataRVA]
	mov [DataRVA], eax
	
	mov eax, [esi.LoaderInfo.DataSize]
	mov [DataSize], eax
	
	mov eax, [esi.LoaderInfo.RDataRVA]
	mov [RDataRVA], eax
	
	mov eax, [esi.LoaderInfo.RDataSize]
	mov [RDataSize], eax
	
	mov eax, [esi.LoaderInfo.OriginalITRVA]
	mov [OriginalITRVA], eax
	
	mov eax, [esi.LoaderInfo.OriginalETRVA]
	mov [OriginalETRVA], eax
	
	mov eax, [k32_first]
	mov [apiGetProcAddress], eax
	
	add eax, 4
	mov [apiLoadLibraryA], eax
	
	pop ebx
	pop edi
	pop esi
	ret
	
PrepareAndCopyLdrs:
	push ebp
	mov ebp, esp
	sub esp, 10Ch
	
	; [ebp-04] = 1st stage loader size
	
	push esi
	
	mov eax, [esi.LoaderInfo.CurrentOffset]
	mov ebx, eax
	add eax, 64h
	invoke IntervalRand, ebx, eax
	mov [NextStageOff], eax
	
	mov [esi.LoaderInfo.CurrentOffset], eax
	
	mov edi, [esi.LoaderInfo.pPEInfo]
	invoke OffsetToRva, eax, [edi.PEInfo.ImageNtHeaders]
	mov [NextStageRVA], eax
	
	; builds first stage loader in memory
	lea ebx, [ebp-10Ch]
	invoke Build1Loader, edi, ebx, [NextStageRVA]
	mov [ebp-04], eax
	
	; the 1st stage loader has been built, now the .text section gets encrypted, before moving the ep
	lea eax, [ebp-10Ch]
	invoke EncryptCode, edi, eax
	
	lea eax, real_loader_start
	add eax, size_ldr_data
	invoke EncryptData, edi, eax
	
	;two-pass encryption of the .rdata section
	;1st pass: encrypt using the last 12 bytes of the loader, no bp this way
	lea eax, real_loader_start
	add eax, build_code_key - real_loader_start
	sub eax, 12
	invoke EncryptRData, edi, eax
	
	;2nd pass: encrypt using the last 12 bytes of seh_decrypt
	lea eax, seh_decrypt
	add eax, build_code_key - seh_decrypt
	sub eax, 12
	invoke EncryptRData, edi, eax
	
	mov eax, [esi.LoaderInfo.CurrentOffset]
	add eax, 64h ; we store the original ep 100 bytes away from 2nd stage loader
	mov [OldCodeOffs], eax
	
	mov ebx, [edi.PEInfo.ImageNtHeaders]
	
	; this moves the original entry point of the dll
	push esi
	push edi
	push eax
	invoke RvaToOffset, [ebx.IMAGE_NT_HEADERS.OptionalHeader.IMAGE_OPTIONAL_HEADER.AddressOfEntryPoint], [edi.PEInfo.ImageNtHeaders]
	add eax, [edi.PEInfo.FileBase]
	mov esi, eax
	pop eax
	add eax, [edi.PEInfo.FileBase]
	mov edi, eax
	mov ecx, [ebp-04]
	rep movsb
	pop edi
	pop esi
	
	; copy the first stage loader
	mov eax, [OEPRva]
	invoke RvaToOffset, eax, [edi.PEInfo.ImageNtHeaders]
	add eax, [edi.PEInfo.FileBase]
	push esi
	push edi
	lea esi, [ebp-10Ch]
	mov edi, eax
	mov ecx, [ebp-04]
	rep movsb
	pop edi
	pop esi
	
	add [esi.LoaderInfo.CurrentOffset], 64h
	mov eax, [ebp-04]
	add [esi.LoaderInfo.CurrentOffset], eax
	mov [OldCodeSize], eax
	
	add [esi.LoaderInfo.CurrentOffset], real_loader_size
	
	; fills the data section of the real loader
	call PrepareRealLoader
	
	; copy the real loader
	lea eax, real_loader_start
	mov ebx, [esi.LoaderInfo.CurrentOffset]
	sub ebx, real_loader_size
	add ebx, [edi.PEInfo.FileBase]
	push esi
	push edi
	mov esi, eax
	mov edi, ebx
	mov ecx, real_loader_end - real_loader_start
	rep movsb
	pop edi
	pop esi
	
	mov eax, [esi.LoaderInfo.CurrentOffset]
	sub eax, real_loader_size
	invoke OffsetToRva, eax, [edi.PEInfo.ImageNtHeaders]
	mov [RealLdrRVA], eax
	
	mov eax, size_ldr_data
	push eax
	mov eax, real_loader_size
	push eax
	push dword ptr [RealLdrRVA]
	mov eax, [NextStageOff]
	inc eax ; since the first instruction was generated by stage 1 loader, we skip it
	add eax, [edi.PEInfo.FileBase]
	push eax
	push [esi.LoaderInfo.pPEInfo]
	call Build15Loader
	
	pop esi
	mov esp, ebp
	pop ebp
	ret	

;	 Random Code Generator

BeginRandomGenerator:
	;int 3
	push ebp
	mov ebp, esp
	sub esp, 20h
	
	pushad
	
	mov esi, real_loader_start_first
	mov ecx, real_loader_enc
	;int 3
	
@1000:
	xor eax, eax
	mov dword ptr [ebp-04h], esi
	mov dword ptr [ebp-08h], ecx
	
	mov ax, word ptr [esi]
	cmp ax, 44c7h
	jz @2003
	cmp al, 35h
	jz @2003
	push offset TmpStruct
	push esi
	call hde32_disasm
	add esp, 08h
	test eax, eax
	jz @2000
	
	lea edi, TmpStruct
	movzx eax, byte ptr [edi+hde32s.len]
	cmp eax, 0ah				; THIS IS A COSTANT!
	jge @2001					; Out of this costant!
	
	mov esi, dword ptr [ebp-04h]	; Load Effective addr.
	add esi, eax				; Go to next instruction (after end)
	
	push ecx
	push edi
	
	mov eax, 90909090h
	mov ecx, -1
	xchg edi, esi
	repe scasb
	not ecx
	dec ecx
	mov eax, ecx
	pop edi
	pop ecx
	cmp eax, 0ah
	jge @2002
	cmp eax, 01h
	jbe @2002
	mov [ebp-10h], eax
	dec eax
	dec eax
	push eax
	call AssembleJmpShort
	mov dword ptr [ebp-0ch], eax
	mov esi, [ebp-04h]
	lea edi, TmpStruct
	movzx eax, byte ptr [edi+hde32s.len]
	sub ecx, eax
	sub ecx, dword ptr [ebp-10h]
	add esi, eax
	;sub ecx, 2
	;add esi, 2
	mov eax, dword ptr [ebp-0ch]
	mov word ptr [esi], ax
	; Genera codice a cazzo?
	push ecx
	push edi
	push eax
	push edx
	mov ecx, dword ptr [ebp-10h]
	mov edi, esi
	add edi, 2
	dec ecx
	dec ecx
@1:
	rdtsc
	stosb
	loop @1
	
	pop edx
	pop eax
	pop edi
	pop ecx
	mov esi, dword ptr [ebp-04h]
	movzx eax, byte ptr [edi+hde32s.len]
	add esi, eax
	add esi, dword ptr [ebp-10h]
	jmp @3000
	
@2000:	; Invalid Opcode!
	mov ecx, dword ptr [ebp-08h]
	mov esi, dword ptr [ebp-04h]
	dec ecx
	inc esi
	jmp @3000
@2001: ; Big opcode ? 
	mov ecx, dword ptr [ebp-08h]
	mov esi, dword ptr [ebp-04h]
	sub ecx, eax
	add esi, eax
	jmp @3000
@2002:
	lea edi, [TmpStruct]
	movzx eax, byte ptr [edi+hde32s.len]
	jmp @2001
@2003:
	mov ecx, dword ptr [ebp-08h]
	mov esi, dword ptr [ebp-04h]
	dec ecx
	inc esi
	jmp @3000
@3000:
	;test ecx, 80000000h
	;jz .3001
	cmp ecx, 09h
	jge @1000
@3001:	
	popad
	mov esp, ebp
	pop ebp
	ret
	
;	AssembleJmpShort
AssembleJmpShort:			; Return in EAX
	xor eax, eax
	mov eax, dword ptr [esp+04h]
	shl eax, 8
	add eax, 0ebh
	ret 04h
	
; 	Calculate Disp. offset
DisplacementOffset:
	push ebp
	mov ebp, esp
	
	xor eax, eax
	
	mov esp, ebp
	pop ebp
	ret

	hde32s_size EQU 37

hde32_disasm:
	pushad
	mov	edi,[esp+40]
	xor	eax,eax
	xor	ecx,ecx
	xor	ebx,ebx
	cdq
	mov	cl, hde32s_size
	rep	stosb
	sub	edi, hde32s_size
	mov	esi,[esp+36]
      pref:
	lodsb
	cmp	al,	0f3h
	jz	pref_rep
	cmp	al, 0f2h
	jnz	no_pref_rep
      pref_rep:
	mov	[edi+hde32s.p_rep],al
	jmp	short pref
      no_pref_rep:
	cmp	al, 0f0h
	jnz	no_pref_lock
	mov	[edi+hde32s.p_lock],al
	jmp	short pref
      no_pref_lock:
	cmp	al, 02eh
	jz	pref_seg
	cmp	al, 036h
	jz	pref_seg
	cmp	al, 03eh
	jz	pref_seg
	cmp	al, 26h
	jz	pref_seg
	cmp	al, 64h
	jz	pref_seg
	cmp	al, 65h
	jnz	no_pref_seg
      pref_seg:
	mov	[edi+hde32s.p_seg],al
	jmp	short pref
      no_pref_seg:
	cmp	al, 66h
	jnz	no_pref_66
	mov	[edi+hde32s.p_66],al
	mov	dl,1
	jmp	short pref
      no_pref_66:
	cmp	al, 67h
	jnz	no_pref_67
	mov	[edi+hde32s.p_67],al
	mov	bl,1
	jmp	short pref
      no_pref_67:
	mov	[edi+hde32s.opcode],al
	mov	bh,al
	call	get_delta
      get_delta:
	pop	ecx
	add	ecx,hde_table-get_delta
	cmp	al, 0fh
	jnz	no_opcode2
	lodsb
	mov	[edi+hde32s.opcode2],al
	add	ecx, delta_table
	jmp	short modrm
      no_opcode2:
	cmp	al, 0a0h
	jb	modrm
	cmp	al, 0a3h
	ja	modrm
	mov	dl,bl
      modrm:
	mov	dh,al
	and	dh,3
	shr	al,2
	mov	al,[ecx+eax]
	add	al,dh
	mov	cl,[ecx+eax]
	test cl,  C_MODRM
	jz imm
	lodsb
	mov	[edi+hde32s.modrm],al
	mov	ch,al
	shr	ch,6
	mov	[edi+hde32s.modrm_mod],ch
	mov	dh,al
	and	dh,7
	mov	[edi+hde32s.modrm_rm],dh
	shl	al,2
	shr	al,5
	mov	[edi+hde32s.modrm_reg],al
	cmp	al,1
	lodsb
	ja	no_f7
	cmp	bh, 0f6h
	jnz	no_f6
	or	cl,C_DATA8
      no_f6:
	cmp	bh, 0f7h
	jnz	no_f7
	or	cl,C_PRE66
      no_f7:
	xor	bh,bh
	or	ch,ch
	jnz	no_mod_0
	or	bl,bl
	jz	no_p67
	cmp	dh,6
	jnz	no_mod_0
	mov	bh,2
	jmp	short no_mod_0
      no_p67:
	cmp	dh,5
	jnz	no_mod_0
	mov	bh,4
      no_mod_0:
	cmp	ch,1
	jnz	no_mod_1
	mov	bh,1
      no_mod_1:
	cmp	ch,2
	jnz	no_mod_2
	or	bl,bl
	jz	no_p67_
	mov	bh,2
	jmp	short no_mod_2
      no_p67_:
	mov	bh,4
      no_mod_2:
	cmp	ch,3
	jz	disp
	cmp	dh,4
	jnz	disp
	or	bl,bl
	jnz	disp
	inc	esi
	mov	[edi+hde32s.sib],al
	mov	ah,al
	shr	ah,6
	mov	[edi+hde32s.sib_scale],ah
	mov	ah,al
	shl	ah,2
	shr	ah,5
	mov	[edi+hde32s.sib_index],ah
	and	al,7
	mov	[edi+hde32s.sib_base],al
	cmp	al,5
	jnz	disp
	or	ch,ch
	jz	mod_0
	cmp	ch,2
	jnz	disp
      mod_0:
	mov	bh,4
      disp:
	dec	esi
	cmp	bh,1
	jnz	no_disp8
	lodsb
	mov	[edi+hde32s.disp8],al
      no_disp8:
	cmp	bh,2
	jnz	no_disp16
	lodsw
	mov	[edi+hde32s.disp16],ax
      no_disp16:
	cmp	bh,4
	jnz	imm
	lodsd
	mov	[edi+hde32s.disp32],eax
      imm:
	test	cl,C_PRE66
	jz	no_pre66
	test	cl,C_REL32
	jz	no_rel32
	or	dl,dl
	jz	no_p66
	lodsw
	mov	[edi+hde32s.rel16],ax
	jmp	short hde_dasm_end
      no_p66:
	lodsd
	mov	[edi+hde32s.rel32],eax
	jmp	short hde_dasm_end
      no_rel32:
	or	dl,dl
	jz	no_p66_
	lodsw
	mov	[edi+hde32s.imm16],ax
	jmp	short no_pre66
      no_p66_:
	lodsd
	mov	[edi+hde32s.imm32],eax
      no_pre66:
	test	cl,C_DATA32
	jz	no_imm32
	lodsd
	mov	[edi+hde32s.imm32],eax
      no_imm32:
	test	cl,C_DATA16
	jz	no_imm16
	lodsw
	mov	[edi+hde32s.imm16],ax
      no_imm16:
	test	cl,C_DATA8
	jz	no_imm8
	lodsb
	mov	[edi+hde32s.imm8],al
      no_imm8:
	test	cl,C_REL32
	jz	no_rel32_
	lodsd
	mov	[edi+hde32s.rel32],eax
      no_rel32_:
	test	cl,C_REL8
	jz	hde_dasm_end
	lodsb
	mov	[edi+hde32s.rel8],al
      hde_dasm_end:
	xchg	eax,esi
	sub	eax,[esp+36]
	stosb
	mov	[esp+28],eax
	popad
	ret

	include table.ash
END